export interface TransitionAbortedError extends Error {
    name: 'TransitionAborted';
    code: 'TRANSITION_ABORTED';
}
export declare function buildTransitionAborted(): TransitionAbortedError;
export declare function isTransitionAborted(maybeError: unknown): maybeError is TransitionAbortedError;
interface Abortable<T extends boolean> {
    isAborted: T;
    [key: string]: unknown;
}
export declare function throwIfAborted(maybe: Abortable<true>): never;
export declare function throwIfAborted(maybe: unknown): void;
export {};
